public class Application
{
    private Gtk.Builder builder;

    private SudokuGame game;

    private Gtk.Window window;
    private SudokuView view;

    public Application ()
    {
        builder = new Gtk.Builder ();
        try
        {
            builder.add_from_file ("data/gnome-sudoku.ui");
        }
        catch (GLib.Error e)
        {
            GLib.warning ("Could not load UI: %s", e.message);
        }
        window = (Gtk.Window) builder.get_object ("sudoku_app");
        var main_vbox = (Gtk.VBox) builder.get_object ("main_vbox");

        game = new SudokuGame ();
        view = new SudokuView (game);
        view.show ();
        main_vbox.pack_start (view);
    }
    
    public void start ()
    {
        show ();
    }

    public void show ()
    {
        window.show ();
    }
}

class GlChess
{
    public static int main (string[] args)
    {
        Gtk.init (ref args);

        Application app = new Application ();
        app.start ();

        Gtk.main ();

        return 0;
    }
}
