public class SudokuCell
{
    public int row;
    public int col;

    private int _value = 0;
    public int value
    {
        set
        {
            if (_value == value)
                return;
            _value = value;
            value_changed ();
        }
        get { return _value; }
    }

    public bool is_fixed = false;

    public signal void value_changed ();
    
    public SudokuCell (int row, int col)
    {
        this.row = row;
        this.col = col;
    }
}

public class SudokuGame
{
    public SudokuCell[,] cells;
    
    public signal void cell_changed (SudokuCell cell);

    public SudokuGame ()
    {
        cells = new SudokuCell[9,9];
        for (int row = 0; row < 9; row++)
            for (int col = 0; col < 9; col++)
            {
                var cell = new SudokuCell (row, col);
                cells[row, col] = cell;
                cell.value_changed.connect (cell_changed_cb);
            }
    }

    private void cell_changed_cb (SudokuCell cell)
    {
        cell_changed (cell);
    }
}
